﻿using System.Windows;
using System.Linq;
using ThinkGeo.MapSuite.WpfDesktopEdition;
using System.Reflection;
using System.Windows.Controls;
using ThinkGeo.MapSuite.Core;

namespace RemoveUnloadOverlaySample
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void WpfMap_Loaded(object sender, RoutedEventArgs e)
        {
            Map1.MapUnit = GeographyUnit.DecimalDegree;
            LayerOverlay overlay = new LayerOverlay();
            Map1.Overlays.Add(overlay);

            ShapeFileFeatureLayer streetsLayer = new ShapeFileFeatureLayer("path");
            streetsLayer.ZoomLevelSet.ZoomLevel01.DefaultLineStyle = LineStyles.MajorStreet3;
            streetsLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            overlay.Layers.Add(streetsLayer);
            Map1.CurrentExtent = new RectangleShape(-141, 82, -52, 41);
        }

        private void btnRemoveUnloadOverlay_Click(object sender, RoutedEventArgs e)
        {
            var piDrawingCanvas = typeof(TileOverlay).GetProperty("DrawingCanvas", BindingFlags.Instance | BindingFlags.NonPublic);
            for (int i = Map1.Overlays.Count - 1; i >= 0; i--)
            {
                
                var overlay = Map1.Overlays[i] as TileOverlay;
                if (overlay != null)
                {
                    var drawingCanvas = piDrawingCanvas.GetValue(overlay) as Canvas;
                    var tiles = Helper.FindChildren<ThinkGeo.MapSuite.WpfDesktopEdition.Tile>(drawingCanvas);
                    if (tiles.Any(p => p.ImageSource == null || p.ImageSource.Width == 0))
                    {
                        Map1.Overlays.RemoveAt(i);
  			overlay.Dispose();
                        ShapeFileFeatureLayer streetsLayer = new ShapeFileFeatureLayer("path");
                        streetsLayer.ZoomLevelSet.ZoomLevel01.DefaultLineStyle = LineStyles.MajorStreet3;
                        streetsLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
                        var newOverlay = new LayerOverlay();
                        newOverlay.Layers.Add(streetsLayer);
                        Map1.Overlays.Insert(i, newOverlay);
                    }

                }
            }

            Map1.Refresh();
        }
    }

}
